#!/usr/bin/env python
# pyserial is needed http://pyserial.sourceforge.net/
# If running as http user, you'll need to add it to your com. group 
# ls -l /dev/ttyACM*
# crw-rw---- 1 root uucp 188, 0 Feb 18 09:02 /dev/ttyACM0
# usermod -aG uucp http
# Then create a ramdisk or use tmpfs !

import serial, sys
import time
import glob

PORT = (glob.glob("/dev/ttyACM*")) # Detect the arduino port
#ser = serial.Serial(PORT[0], 921600, timeout=10)
ser = serial.Serial(PORT[0], 19200, timeout=10)


if len(sys.argv) == 1:
	print ("Abording: Provide an argument"), sys.exit()
elif len(sys.argv) > 2:
    print ("Abording: Too many arguments"), sys.exit()
else:
	if sys.argv[1] == 'relect': # Elect & reset counter
		ser.write("relect\n".encode("utf-8"))
		line = ser.readline(16).decode("utf-8")
		print(line)
	elif sys.argv[1] == 'rgas': # Gas & reset counter
		ser.write("rgas\n".encode("utf-8"))
		line = ser.readline(16).decode("utf-8")
		print(line)
	elif sys.argv[1] == 'rwater': # Water & reset counter
		ser.write("rwater\n".encode("utf-8"))
		line = ser.readline(16).decode("utf-8")
		print(line)
	elif sys.argv[1] == 'live': # Infinite filling loop for live data
		while True:
			ser.write("le\n".encode("utf-8")) # Elect live
			line = ser.readline(16).decode("utf-8")
			time.sleep(0.05) # 50ms
			ser.write("gs\n".encode("utf-8")) # Gas state
			line += ser.readline(16).decode("utf-8")
			time.sleep(0.05)
			ser.write("ws\n".encode("utf-8"))  # Water state
			line += ser.readline(16).decode("utf-8")
			f = open('/tmp/metern.txt','w+')
			f.write(line)
			time.sleep(1)
		f.close()
	else: 
		print ("Abording:", sys.argv[1] ,"is not a valid argument"),sys.exit()

ser.flushInput()
ser.flushOutput()
ser.close()
quit()
